foreach name [array names env STOOOP*] {unset env($name)}                                ;# reset any existing environment variables
set env(STOOOPCHECKOBJECTS) {}
source stooop.tcl
namespace import stooop::*

### objects checking with objects printing procedure

# expected output:
## stooop::printObjects invoked from main script:
## stooop::printObjects invoked from main script:
## ::a(1) created in main script
## stooop::printObjects invoked from main script:
## ::a(1) created in main script
## ::a(2) created in ::p
## stooop::printObjects invoked from main script:
## ::a(1) created in main script
## ::a(2) created in ::p
## ::a(3) created in ::n::p
## stooop::printObjects invoked from main script:
## ::a(2) created in ::p
## ::a(3) created in ::n::p
## stooop::printObjects invoked from main script:
## ::a(3) created in ::n::p
## stooop::printObjects invoked from main script:
## stooop::printObjects invoked from main script:
## stooop::printObjects invoked from main script:
## ::A(4) created in main script
## stooop::printObjects invoked from main script:
## ::A(4) created in main script
## ::A(5) created in ::q
## stooop::printObjects invoked from main script:
## ::A(4) created in main script
## ::A(5) created in ::q
## ::A(6) created in ::m::q
## stooop::printObjects invoked from main script:
## ::A(5) created in ::q
## ::A(6) created in ::m::q
## stooop::printObjects invoked from main script:
## ::A(6) created in ::m::q
## stooop::printObjects invoked from main script:

class a {}
proc a::a {this} {}
proc a::~a {this} {}
proc p {} {
    new a
}
namespace eval n {
    proc p {} {
        new a
    }
}
stooop::printObjects
new a
stooop::printObjects
p
stooop::printObjects
n::p
stooop::printObjects
delete 1
stooop::printObjects
delete 2
stooop::printObjects
delete 3
stooop::printObjects

class A {
    proc A {this} {}
    proc ~A {this} {}
}
proc q {} {
    new A
}
namespace eval m {
    proc q {} {
        new A
    }
}
stooop::printObjects
new A
stooop::printObjects
q
stooop::printObjects
m::q
stooop::printObjects
delete 4
stooop::printObjects
delete 5
stooop::printObjects
delete 6
stooop::printObjects
